$fn=50;

wall_thickness = 8;
hook_thickness = 4.7;
hook_totalheight = 50;
hook_height = 20;
hook_width = 15;
hook_depth = 10;
hook_wall_cliplength = 30;
edge_radius = 0.5;

// Vertical cube
radcube(hook_thickness, hook_totalheight, hook_width, edge_radius);

// Horizontal cube top
translate([hook_thickness-2*edge_radius, hook_totalheight-hook_thickness, 0])
radcube(wall_thickness+4*edge_radius, hook_thickness, hook_width, edge_radius);

// Horizontal cube bottom with vertical hook
hull() {
    translate([-hook_depth-hook_thickness, hook_height-2, hook_width/2])
    rotate([0, 90,0])
    cylinder(hook_thickness, 2, 2);
    translate([-hook_depth-hook_thickness, 0, 0])
    radcube(hook_thickness, hook_thickness+hook_height/2, hook_width, edge_radius); 
}
    translate([-(hook_depth+hook_thickness)+2*edge_radius, 0, 0])
    radcube(hook_depth+hook_thickness+2*edge_radius, hook_thickness, hook_width, edge_radius); 

// Vertical cube top
translate([wall_thickness+hook_thickness, hook_totalheight-hook_wall_cliplength, 0])
 
radcube(hook_thickness, hook_wall_cliplength, hook_width, edge_radius);


// Module for radiuses on cubes
module radcube_(xlen,ylen,zlen,radius){
    hull(){
        translate([radius,radius,radius]) sphere(r=radius);
        translate([xlen + radius , radius , radius]) sphere(r=radius);
        translate([radius , ylen + radius , radius]) sphere(r=radius);    
        translate([xlen + radius , ylen + radius , radius]) sphere(r=radius);
        translate([radius , radius , zlen + radius]) sphere(r=radius);
        translate([xlen + radius , radius , zlen + radius]) sphere(r=radius);
        translate([radius,ylen + radius,zlen + radius]) sphere(r=radius);
        translate([xlen + radius,ylen + radius,zlen + radius]) sphere(r=radius);
    }
}

module radcube(xlen,ylen,zlen,radius){ 
    radcube_(xlen-radius*2,ylen-radius*2,zlen-radius*2,radius); 
}